Name: rubygems
Version: 0.6.1
Release: alt2
Summary: A package management framework for the Ruby programming language
License: Ruby's
Group: Development/Ruby
Url: http://rubygems.rubyforge.org/wiki/wiki.pl
Source: rubygems-0.6.1.tgz
Patch: rubygems.patch

BuildRequires: ruby >= 1.8.1-alt9, libruby-devel

%description
RubyGems is a package management framework for the Ruby programming language.

%prep
%setup
%patch -p1

%build

%install

%ruby_begin
	require "find"
	require "ftools"

	$site_libdir = "%buildroot%ruby_sitelibdir"

	libdir = "lib"
	Find.find(libdir) do |f|
	  next unless FileTest.file?(f)
	  next if (f = f[libdir.length+1..-1]) == nil
    	  File.mkpath(File.join($site_libdir, File.dirname(f)))
	  File.install(File.join("lib", f), File.join($site_libdir, f), 0644, true)
	end

	bindir = "%buildroot%_bindir"
	File.mkpath(bindir)
	Find.find("bin") do |f|
	  next if FileTest.directory?(f)
	  next if f =~ /\.rb$/
	  source = f
	  target = File.join(bindir, File.basename(f))
	  File.install(source, target, 0755, true)
	end
%ruby_end

%__mkdir_p %buildroot%_sysconfdir/rpm/macros.d/
%ruby_begin
	puts "%%rubygemsdir /usr/lib/ruby/gems/1.8/"
	puts "%%gem_install gem --gen-rdoc --install-stub %ruby_sitelibdir --prefix %buildroot -i"
%ruby_end > %buildroot%_sysconfdir/rpm/macros.d/%name

%post
%ruby_begin
	require "rbconfig"
	require "ftools"

	gem_dir = File.join(Config::CONFIG["libdir"], "ruby", 
		"gems", Config::CONFIG["ruby_version"])
	["specifications", "cache", "gems"].each do |subdir|
	  File.mkpath(File.join(gem_dir, subdir))
	end
  
	begin
	  Dir.glob(File.join(gem_dir, "*")) do |file|
	    next unless file =~ /.*-[0-9]+\..*/
	    FileUtils.mv(file, File.join(gem_dir, "gems"))
	  end
	rescue
	  puts "ERROR: Failed to migrate the old gems located in..."
	  puts "  #{gem_dir}"
	  puts "  ...to the #{File.join(gem_dir, '\'gems\'')} directory"
	  puts "  You should move them manually, or your gems DB will be an invalid state"
	  puts "Backtrace follows:"
	  puts $!
	  puts $!.backtrace.join("\n")
	end

	Dir.chdir("%_docdir/%name-%version/sources")
	  load("sources.gemspec")
	  spec = Gem.sources_spec
	  gem_file = Gem::Builder.new(spec).build
	  Gem::Installer.new(gem_file).install(true, Gem.dir, nil)
	Dir.chdir("../..")
%ruby_end

%files
%doc ChangeLog README Releases TODO packages/sources
%ruby_sitelibdir/*
%_bindir/*
%_sysconfdir/rpm/macros.d/%name

%changelog
* Wed Jul 07 2004 Kirill A. Shutemov <kas@altlinux.ru> 0.6.1-alt2
- Patch to add --prefix option (Kirill A. Shutemov)
- Add rpm macros

* Wed Jun 02 2004 Kirill A. Shutemov <kas@altlinux.ru> 0.6.1-alt1
- First build for ALT Project 

